package cn.com.qmth.stmms.ms.core.repository;

import cn.com.qmth.stmms.ms.core.domain.MarkLog;
import cn.com.qmth.stmms.ms.core.domain.user.MarkUser;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author ting.yin
 * @date 2016年10月21日
 */
@Repository
public interface MarkLogRepo extends JpaRepository<MarkLog, Long>, JpaSpecificationExecutor<MarkLog> {

    /**
     * 根据条件查询最近一条日志
     *
     * @param createUserId
     * @param operType
     * @param subject
     * @param examNumber
     * @return
     */
    public MarkLog findTopByCreateUserIdAndOperTypeAndSubjectAndExamNumberOrderByCreateTimeDesc(Long createUserId, Integer operType, String subject, String examNumber);

    List<MarkUser> findByCreateUserId(Long userId);

    void deleteByPaperIdIn(List<Long> paperIds);
}
